# Android 15 Migration guide

## 1 - Check major changes

Android offers a clear and exhaustive [documentation](https://developer.android.com/about/versions/15) listing the new features and changes related to Android 15.

It is necessary to read this documentation **before** modifying any code in your project.

{% hint style="warning" %}
You must consider the two main categories of behaviours changes related to Android 15:

* [Behavior changes: all apps](https://developer.android.com/about/versions/15/behavior-changes-all)
* [Behavior changes: Apps targeting Android 15 or higher](https://developer.android.com/about/versions/15/behavior-changes-15)
  {% endhint %}

## 2 - Targeting Android 15 in your project

To make your app fully compatible with Android 15, update the `targetSdkVersion` and `compileSdkVersion` to `35` in your project app.

## 3 - Apply changes

It's now time to update your code once the previous steps are taken into account.

DriveQuant recommends to specifically pay attention about the [Edge-to-edge enforcement](https://developer.android.com/about/versions/15/behavior-changes-15#edge-to-edge) which is now enabled by default when your app is targeting Android 15.

{% hint style="info" %}
If your app is not ready to support edge-to-edge, you can disable it by using the [`windowOptOutEdgeToEdgeEnforcement`](https://developer.android.com/reference/android/R.attr#windowOptOutEdgeToEdgeEnforcement)attribute.
{% endhint %}

## 4 - Update the DriveKit SDK

After you have checked that your project is working properly and updated the `targetSdkVersion` and `compileSdkVersion`, you need to update the DriveKit SDK.

* DriveKit internal modules that support Android 15 are versions `2.4.0` and above.
* DriveKit UI modules that support Android 15 are versions `2.4.0` and above.&#x20;

{% hint style="info" %}
The latest DriveKit versions are listed in the changelog:

* [For internal modules](/release-notes/changelog/android.md)&#x20;
* [For UI modules](/release-notes/changelog/ui-android.md)
  {% endhint %}

## 5 - Tests 🚗

The last part is to ensure that the app is working as expected. The best way to do this is to compare your app's behaviour with the [DriveQuant's app](https://play.google.com/store/apps/details?id=com.drivequant) and/or the [DriveKit Demo App](https://github.com/DriveQuantPublic/drivekit-ui-android); which already support Android 15.&#x20;

If you experience any problems with DriveKit, please contact [us](mailto:contact@drivequant.com).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.drivequant.com/get-started-drivekit/android/android-15-migration-guide.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
